//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define USERQUIT_SIGPIPE 1
#define USERQUIT_QUIT 2
#define USERQUIT_EOF 3
#define USERQUIT_TIMEOUT 4
#define USERQUIT_ERROR 5
#define USERQUIT_SENDQEXCEEDED 6
#define USERQUIT_EXCESSFLOOD 7
#define USERQUIT_REGISTERTIMEOUT 8
#define USERQUIT_NETSPLIT 9
#define USERQUIT_LINKCLOSE 10
#define USERQUIT_COLLISION 11
#define USER_MAXSENDBUFFERS 20
#define USER_RECVBUFFERSIZE 1024
struct weircd_user_floodprotect {
	int floodpoints;
	long long lastlist;
	long long lastmotd;
};
struct weircd_user_chaninfo {
	int chanid;
	bool iamop;
	bool iamhalfop;
	bool iamvoice;
	bool iamprotected;
};
struct weircd_user {
#ifdef IPV6
	unsigned char ip[INET6_ADDRSTRLEN+1];  // new size of the array
#else
	unsigned char ip[17];
#endif
	unsigned char* sendbuffer[USER_MAXSENDBUFFERS];
	unsigned char recvbuffer[USER_RECVBUFFERSIZE];
	unsigned char host[COMPILEOPTION_MAXHOSTLEN];
	unsigned char pass[200];
	unsigned char* quitreason;
	long long lastnickchange;
	int mastersocketid;//to close the user down if listener port they connected to is closed
	long CONNECTtime;
	bool authed;//001 message passed
	long long authtime;
	long authpongvalue;
	int pleaseremove;
	int socketunselected;//is socket still watched by select()?
	int sendblocks;//sendblocks of this user still waiting to be sent
	bool ircop;
	bool globop;
	bool servicesop;
	int hopcount;
	int linktcpdata;
	unsigned char* servname;
	unsigned char* awayreason;
	long long pleaseremove_time;
	bool sendbeforeremove;
	bool mode_invisible;
	bool mode_walluser;
	bool mode_bot;
	long long logintime;
	int needstimeout; //uses a registered nick without being logged in, needs to get force renamed after login timeout
#ifdef SERVICES_ENABLED
	int notifyregistered; //send a notice after all the login stuff to indicate that the user uses a registered nick
	unsigned char* accountname;
#endif
	int socket;
	long long ping_lastping;
	long long ping_waitingforpong;
	long ping_pingval;
	struct weircd_user_floodprotect floodprotect;
	struct weircd_user_chaninfo* chan[COMPILEOPTION_MAXCHANSPERUSER];
	unsigned char nickname[COMPILEOPTION_MAXNICKLEN + 1];
	unsigned char suserid[COMPILEOPTION_MAXUSERIDLEN + 1];
	unsigned char realname[COMPILEOPTION_MAXREALNAMELEN + 1];
};

struct weircd_user* userpointers[COMPILEOPTION_MAXUSERS];
bool useraffected[COMPILEOPTION_MAXUSERS]; //needed for e.g. /who or tellaffectedusers();
#define up userpointers
int userslotcount = 0;

